
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Mysql limit 优化，百万至千万级快速分页 复合索引的引用并应用于轻量级框架_Mysql / iVAN</title>

    <meta name="description" content="Mysql limit 优化，百万至千万级快速分页 复合索引的引用并应用于轻量级框架_Mysql MySql 这个数据库绝对是适合dba级的高手去玩的,一般做一点1万篇新闻的小型系统怎么写都可以,用xx框架可以实现快速开发.可是数据量到了10万,百万至千万,他的性能还能那么高吗?一点小小的失误,可能造成整个系统的改写,甚至更本系统无法正常运行!好了,不那么多废话了.用事实说话,看例子: 数据表 collect ( id, title ,info ,vtype) 就这4个字段,其中 title 用定长,info 用text, id 是逐渐,vtype是tinyint,vtype是索引.这是一个">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Mysql limit 优化，百万至千万级快速分页 复合索引的引用并应用于轻量级框架_Mysql</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>MySql 这个数据库绝对是适合dba级的高手去玩的，一般做一点1万篇新闻的小型系统怎么写都可以，用xx框架可以实现快速开发。可是数据量到了10万，百万至千万，他的性能还能那么高吗？一点小小的失误，可能造成整个系统的改写，甚至更本系统无法正常运行！好了，不那么多废话了。用事实说话，看例子：</p>
<p>数据表 collect ( id, title ,info ,vtype) 就这4个字段，其中 title 用定长，info 用text, id <br />是逐渐，vtype是tinyint，vtype是索引。这是一个基本的新闻系统的简单模型。现在往里面填充数据，填充10万篇新闻。</p>
<p>最后collect 为 10万条记录，数据库表占用硬盘1.6G。OK ,看下面这条sql语句：</p>
<p>select id,title from collect limit 1000,10; 很快；基本上0.01秒就OK，再看下面的</p>
<p>select id,title from collect limit 90000,10; 从9万条开始分页，结果？</p>
<p>8-9秒完成，my god 哪出问题了？？？？其实要优化这条数据，网上找得到答案。看下面一条语句:</p>
<p>select id from collect order by id limit 90000,10; 很快，0.04秒就OK。 <br />为什么？因为用了id主键做索引当然快。网上的改法是：</p>
<p>select id,title from collect where id&gt;=(select id from collect order by id <br />limit 90000,1) limit 10;</p>
<p>这就是用了id做索引的结果。可是问题复杂那么一点点，就完了。看下面的语句</p>
<p>select id from collect where vtype=1 order by id limit 90000,10; <br />很慢，用了8-9秒！</p>
<p>到了这里我相信很多人会和我一样，有崩溃感觉！vtype 做了索引了啊？怎么会慢呢？vtype做了索引是不错，你直接 select id from <br />collect where vtype=1 limit 1000,10; <br />是很快的，基本上0.05秒，可是提高90倍，从9万开始，那就是0.05*90=4.5秒的速度了。和测试结果8-9秒到了一个数量级。从这里开始有人提出了分表的思路，这个和discuz <br />论坛是一样的思路。思路如下：</p>
<p>建一个索引表： t (id,title,vtype) 并设置成定长，然后做分页，分页出结果再到 collect 里面去找info 。 <br />是否可行呢？实验下就知道了。</p>
<p>10万条记录到 t(id,title,vtype) 里，数据表大小20M左右。用</p>
<p>select id from t where vtype=1 order by id limit 90000,10; <br />很快了。基本上0.1-0.2秒可以跑完。为什么会这样呢？我猜想是因为collect 数据太多，所以分页要跑很长的路。limit <br />完全和数据表的大小有关的。其实这样做还是全表扫描，只是因为数据量小，只有10万才快。OK， 来个疯狂的实验，加到100万条，测试性能。</p>
<p>加了10倍的数据，马上t表就到了200多M，而且是定长。还是刚才的查询语句，时间是0.1-0.2秒完成！分表性能没问题？错！因为我们的limit还是9万，所以快。给个大的，90万开始</p>
<p>select id from t where vtype=1 order by id limit 900000,10; 看看结果，时间是1-2秒！</p>
<p>why ?? 分表了时间还是这么长，非常之郁闷！有人说定长会提高limit的性能，开始我也以为，因为一条记录的长度是固定的，mysql <br />应该可以算出90万的位置才对啊？ 可是我们高估了mysql 的智能，他不是商务数据库，事实证明定长和非定长对limit影响不大？ 怪不得有人说 <br />discuz到了100万条记录就会很慢，我相信这是真的，这个和数据库设计有关！</p>
<p><strong>难道MySQL 无法突破100万的限制吗？？？到了100万的分页就真的到了极限？？？</strong></p>
<p><strong>答案是： NO !!!! <br />为什么突破不了100万是因为不会设计mysql造成的。下面介绍非分表法，来个疯狂的测试！一张表搞定100万记录，并且10G <br />数据库，如何快速分页！</strong></p>
<p>好了，我们的测试又回到 collect表，开始测试结论是： <br />30万数据，用分表法可行，超过30万他的速度会慢道你无法忍受！当然如果用分表+我这种方法，那是绝对完美的。但是用了我这种方法后，不用分表也可以完美解决！</p>
<p>答案就是：复合索引！ 有一次设计mysql索引的时候，无意中发现索引名字可以任取，可以选择几个字段进来，这有什么用呢？开始的select id from <br />collect order by id limit 90000,10; 这么快就是因为走了索引，可是如果加了where 就不走索引了。抱着试试看的想法加了 <br />search(vtype,id) 这样的索引。然后测试<br />select id from collect where vtype=1 limit 90000,10; 非常快！0.04秒完成！</p>
<p>再测试: select id ,title from collect where vtype=1 limit 90000,10; <br />非常遗憾，8-9秒，没走search索引！</p>
<p>再测试：search(id,vtype)，还是select id 这个语句，也非常遗憾，0.5秒。<br /><strong>综上：如果对于有where 条件，又想走索引用limit的，必须设计一个索引，将where <br />放第一位，limit用到的主键放第2位，而且只能select 主键！</strong></p>
<p>完美解决了分页问题了。可以快速返回id就有希望优化limit ， 按这样的逻辑，百万级的limit 应该在0.0x秒就可以分完。看来mysql <br />语句的优化和索引时非常重要的！<br />好了，回到原题，如何将上面的研究成功快速应用于开发呢？如果用复合查询，我的轻量级框架就没的用了。分页字符串还得自己写，那多麻烦？这里再看一个例子，思路就出来了：<br />select * from collect where id in (9000,12,50,7000); 竟然 0秒就可以查完！<br />mygod ，mysql 的索引竟然对于in语句同样有效！看来网上说in无法用索引是错误的！<br />有了这个结论，就可以很简单的应用于轻量级框架了：<br />代码如下：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>$db=dblink(); <br />$db-&gt;pagesize=20; <br />$sql="select id from collect where vtype=$vtype"; <br />$db-&gt;execute($sql); <br />$strpage=$db-&gt;strpage(); <br />//将分页字符串保存在临时变量，方便输出 <br />while($rs=$db-&gt;fetch_array()){ <br />$strid.=$rs['id'].','; <br />} <br />$strid=substr($strid,0,strlen($strid)-1); <br />//构造出id字符串 <br />$db-&gt;pagesize=0; <br />//很关键，在不注销类的情况下，将分页清空，这样只需要用一次数据库连接，不需要再开； <br />$db-&gt;execute("select <br />id,title,url,sTime,gTime,vtype,tag from collect where id in ($strid)"); <br />&lt;?php while($rs=$db-&gt;fetch_array()): ?&gt; <br />&lt;tr&gt; <br />&lt;td&gt; &lt;?php echo $rs['id'];?&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;?php echo $rs['url'];?&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;?php echo $rs['sTime'];?&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;?php echo $rs['gTime'];?&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;?php echo $rs['vtype'];?&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;a href="?act=show&amp;id=&lt;?php echo $rs['id'];?&gt;" <br />target="_blank"&gt;&lt;?php echo $rs['title'];?&gt;&lt;/a&gt;&lt;/td&gt; <br />&lt;td&gt; &lt;?php echo <br />$rs['tag'];?&gt;&lt;/td&gt; <br />&lt;/tr&gt; <br />&lt;?php endwhile; <br />?&gt; <br />&lt;/table&gt; <br />&lt;?php <br />echo $strpage; <br />?&gt;</p>
<p>通过简单的变换，其实思路很简单：1）通过优化索引，找出id，并拼成 "123,90000,12000" 这样的字符串。2）第2次查询找出结果。 <br />小小的索引+一点点的改动就使mysql 可以支持百万甚至千万级的高效分页！ <br />通过这里的例子，我反思了一点：对于大型系统，PHP千万不能用框架，尤其是那种连sql语句都看不到的框架！因为开始对于我的轻量级框架都差点崩溃！只适合小型应用的快速开发，对于ERP,OA，大型网站，数据层包括逻辑层的东西都不能用框架。如果程序员失去了对sql语句的把控，那项目的风险将会成几何级数增加！尤其是用mysql <br />的时候，mysql 一定需要专业的dba 才可以发挥他的最佳性能。一个索引所造成的性能差别可能是上千倍！ <br />PS: <br />经过实际测试，到了100万的数据，160万数据，15G表，190M索引，就算走索引，limit都得0.49秒。所以分页最好别让别人看到10万条以后的数据，要不然会很慢！就算用索引。经过这样的优化，mysql到了百万级分页是个极限！但有这样的成绩已经很不错，如果你是用sqlserver肯定卡死！而160万的数据用 <br />id in (str) 很快，基本还是0秒。如果这样，千万级的数据，mysql应该也很容易应付。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:44:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/%e4%bc%98%e5%8c%96/" title="优化">优化</a>, <a href="https://www.iamivan.net/tag/limit/" title="limit">limit</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Mysql limit 优化，百万至千万级快速分页 复合索引的引用并应用于轻量级框架_Mysql的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1Nw9jp.html" rel="bookmark">MySQL 百万级分页优化&lpar;Mysql千万级快速分页&rpar;&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下分享一点我的经验 一般刚开始学SQL的时候,会这样写 复制代码 代码如下: SELECT * FROM table ORDER BY id LIMIT 1000, 10; 但在数据达到百万级的时候,这样写会慢死 复制代码 代码如下: SELECT * FROM table ORDER BY id LIMIT 1000000, 10; 也许耗费几十秒 网上很多优化的方法是这样的 复制代码 代码如下: SELECT * FROM table WHERE id &gt;= (SELECT id FROM			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOn4k3p.html" rel="bookmark">如何优化Mysql千万级快速分页&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看例子: 数 据表 collect ( id, title ,info ,vtype) 就这4个字段,其中 title 用定长,info 用text, id 是逐渐,vtype是tinyint,vtype是索引.这是一个基本的新闻系统的简单模型.现在往里面填充数据,填充10万篇新闻. 最后collect 为 10万条记录,数据库表占用硬盘1.6G. OK ,看下面这条sql语句: select id,title from collect limit 1000,10; 很快:基本上0.01秒就OK			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6q3OOb.html" rel="bookmark">Mysql limit 优化，百万至千万条记录实现快速分页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可是数据量到了10万,百万至千万,他的性能还能那么高吗?一点小小的失误,可能造成整个系统的改写,甚至更本系统无法正常运行!好了,不那么多废话了.用事实说话,看例子: 数据表 collect ( id, title ,info ,vtype) 就这4个字段,其中 title 用定长,info 用text, id 是逐渐,vtype是tinyint,vtype是索引.这是一个基本的新闻系统的简单模型.现在往里面填充数据,填充10万篇新闻. 最后collect 为 10万条记录,数据库表占用硬盘1.6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYkq35z.html" rel="bookmark">MySQl优化千万数据级快速分页sql语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据表 collect ( id, title ,info ,vtype) 就这4个字段,其中 title 用定长,info 用text, id 是逐渐,vtype是tinyint,vtype是索引.这是一个基本的新闻系统的简单模型.现在往里面填充数据,填充10万篇新闻. 最后collect 为 10万条记录,数据库表占用硬盘1.6G.OK ,看下面这条sql语句:  代码如下 复制代码 select id,title from collect limit 1000,10; 很快:基本上0.01			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1kNdoz.html" rel="bookmark">mysql limit 优化方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql limit 优化方法 SELECT * FROM table  LIMIT [offset,] rows | rows OFFSET offset LIMIT 子句可以被用于强制 SELECT 语句返回指定的记录数.LIMIT 接受一个或两个数字参数.参数必须是一个整数常量.如果给定两个参数,第一个参数指定第一个返回记录行的偏移量,第二个参数指定返回记录行的最大数目.初始记录行的偏移量是 0(而不是 1): 为了与 PostgreSQL 兼容,MySQL 也支持句法: LIMIT #			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlgJlOb.html" rel="bookmark">mysql limit 用法与mysql limit 优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql教程 limit 用法与mysql limit 优化 /* mysql limit 用法2007年11月08日 14:291. select * from tablename &lt;条件语句&gt; limit 100,15 从100条记录后开始取15条 (实际取取的是第101-115条数据) 2. select * from tablename &lt;条件语句&gt; limit 100,-1 从第100条后开始-最后一条的记录 3. select * from tablename &lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2V7LBb.html" rel="bookmark">sql千万级数据库分页与性能优化分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前也有很多人问类似这样的问题,回复这样的问题,我们一般会从索引,水平分区,垂直分区和硬件的升级等方面考虑.    分析   对于千万级数据的分页,要求在秒级内响应,解决方案除了刚列的几个方面考虑,这里说一个非常重要的考虑(评估)是,现实意义. 拿CSDN论坛的那1690万数据来说,我按每页显示200行数据,需要84500页.从站在用户(使用者)角度看,对于查看1万页以后的数据的概率是非常小.假设我们是使用者,让我们一页一页的点,点到100页都够郁闷的了,更何况是1万页后的数据了.这里从现实意			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVGO3Bb.html" rel="bookmark">sql server 千万级数据处理分页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				****** 对象: StoredProcedure [dbo].[sp_GetEmployee] 脚本日期: 11/12/2009 14:10:29 ******/ Create PROCEDURE [dbo].[sp_GetPageList] @tblName varchar(255), -- 表名 @strGetFields varchar(1000) = '*', -- 需要返回的列 @fldName varchar(255)='', -- 排序的字段名 @PageSize int =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7VGDb.html" rel="bookmark">mysql limit 优化方法与详细说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select * from table limit [offset,] rows | rows offset offset limit 子句可以被用于强制 select 语句返回指定的记录数.limit 接受一个或两个数字参数.参数必须是一个整数常量.如果给定两个参数,第一个参数指定第一个返回记录行的偏移量,第二个参数指定返回记录行的最大数目.初始记录行的偏移量是 0(而不是 1): 为了与 postgresql 兼容,mysql教程 也支持句法: limit # offset #. mysql			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyd7Pb.html" rel="bookmark" class="title">jrtplib 组播- 【愁的肝疼】jrtplib库不能接收组播数据</a>
					<div>
						问题描述 [愁的肝疼]jrtplib库不能接收组播数据 已经憋了1个多月了吧使用jrtplib 无论如何都不能接收组播的数据 单播数据可首发 组播数据可发送 下载了最新版本的 jrtplib-3.9. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyOykz.html" rel="bookmark" class="title">Java网络协议 TCP和客户端&sol;服务器范型</a>
					<div>
						服务器|客户端|网络 在网络编程中(同样在其它形式的通讯中,例如数据库编程),使用套接字的应用程序也被分为两类--客户端程序和服务器程序.你可能对&quot;客户端/服务器编程&quot;术语比较熟悉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK985p.html" rel="bookmark" class="title">简单的页面缓冲技术（二）</a>
					<div>
						页面 我的具体实现的例子 为了帮助大家有个感性认识,这里我给出在我的主页上实现的基于文件处理的方法.只有主要的处理代码,不完整. &lt;? 1 $tmpfile=&quot;../tmp/&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB8qAp.html" rel="bookmark" class="title">怎样解决因Seo行业的膨胀带来的外链资源紧缩问题</a>
					<div>
						  说seo行业是网络营销的新兴行业未免太过牵强,因为在国内这个行业从零四年以后发展就很迅猛,尤其是当下简直是如日冲天,这主要和seo行业的性质有关,最主要的一点就是它很适合草根创业,也正是这种发展速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL7Bkb.html" rel="bookmark" class="title">用&OpenCurlyDoubleQuote;网络精确时钟&rdquo;架设时间服务器</a>
					<div>
						又到了月底考勤记录表张贴的日子,又有不少的同事开始为自己多次早退而&quot;叹息&quot;.很多同事都反映是电脑上显示的时间不准确,才导致他们早退.面对这种情况,经理找到了果冻,他要果冻想个办法让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7r98b.html" rel="bookmark" class="title">ADO&period;NET Entity Framework深入分析&comma;Part 6&ndash;处理并发&lpar;Concurrency Handling&rpar;</a>
					<div>
						设置并发模式 Entity Framework 实现了乐观的并发模式(Optimistic Concurrency Model).默认情况下,在实体更新数据提交到数据库时,并不会检查并发.对于高频率的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRPo8z.html" rel="bookmark" class="title">电脑开机密码忘记了</a>
					<div>
						忘记电脑密码了怎么办? 这里有几种方法(主要针对win2000/xp) 一.删除SAM文件,清除Administrator账号密码 Windows 2000所在的WinntSystem32Config ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yX1qz.html" rel="bookmark" class="title">WPS Office段落重排的技巧</a>
					<div>
						在通常情况下,WPS Office用软回车表示换行,用硬回车标记段落结束.有时,当用户用WPS Office打开一个.txt文件或者从网上复制了一些文本后,发现段落中间也是用硬回车来表示换行,这样的文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArEP3p.html" rel="bookmark" class="title">利用PS计算工具调出别致色彩</a>
					<div>
						在这篇PS教程里,将教大家怎样利用Photoshop计算工具来创建一个新的阿尔法通道,并调整出很别致的图片颜色效果.先看一下原图和调整后的对比吧! 图00 因为照片是纵向的,所以,很不好意思你们要一直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG301b.html" rel="bookmark" class="title">XP系统提示&OpenCurlyDoubleQuote;无法访问您要使用的功能所在的网络位置&rdquo;的两种解决方案</a>
					<div>
						XP系统提示&quot;无法访问您要使用的功能所在的网络位置&quot;的两种解决方案   方案一: 直接覆盖安装或者选择修复安装Office即可. 方案二: 1.打开注册表(打开方法:开始-运行,输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNL3OM.html" rel="bookmark" class="title">WinXP如何使用BadCopy光盘数据恢复</a>
					<div>
						  1.安装BadCopy Pro V3.8汉化版,然后运行该软件打开程序主窗口.在&quot;恢复来源&quot;任务窗格中需要选择媒介来源,也就是选择从软盘.光盘.数码或USB等类型的存储器中恢复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEgA5p.html" rel="bookmark" class="title">效果-android 图片大小的处理</a>
					<div>
						问题描述 android 图片大小的处理 我通过SVN上传上去了一个UI界面,第二天,我update了后发现显示的图片缩小了,比以前更清晰了点,但是与这个UI相关的资源和我上传前的资源是一模一样的.然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrGo0M.html" rel="bookmark" class="title">iRedMail批量创建用户</a>
					<div>
						iRedMail提供脚本,可以让用户快速添加用户 MYSQL 你可以编辑create_mail_user_MySQL.sh,修改默认值,如果你安装的时候修改的邮件的存储路径,那么你必须修改脚本的 ST ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7lVwp.html" rel="bookmark" class="title">visual studio-vs设计器无法加载，两次系统重装，两次vs重装。</a>
					<div>
						问题描述 vs设计器无法加载,两次系统重装,两次vs重装. 求救,不想浪费时间在重装了,vs安装路径在D盘D,开发者模式已打开,请求权限已点确定,但就是打不开. 解决方案 重装系统是最好的解决问题的办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5dqxM.html" rel="bookmark" class="title">Apache Mina 2&period;x 超详实例</a>
					<div>
						最近使用Mina开发一个Java的NIO服务端程序,因此也特意学习了Apache的这个Mina框架. 首先,Mina是个什么东西?看下官方网站(http://mina.apache.org/)对它的解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZkLmz.html" rel="bookmark" class="title">云计算服务小笔记</a>
					<div>
						如果你不是很了解云计算服务,那么就请大家和我一起学习一下云计算服务.所谓&quot;云&quot;,其实就是提供资源的网络.&quot;云&quot;中的资源在使用者看来是可以无限扩展的,重要的是它可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYlXEp.html" rel="bookmark" class="title">亚马逊推出了一个平台，用户可以租用，可以使用低配置电脑跑高配置软件，这个平台是什么</a>
					<div>
						问题描述 亚马逊推出了一个平台,用户可以租用,可以使用低配置电脑跑高配置软件,这个平台是什么 前一段 极客头条说了 找不到了 求大家给介绍下 这个平台的名字,怎么租用和基本操作 解决方案 你说的是不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZJ8mz.html" rel="bookmark" class="title">甲骨文CEO埃里森：惠普前CEO是小偷</a>
					<div>
						甲骨文CEO拉里·埃里森 导语: 美国科技博客BusinessInsider今天撰文,总结了甲骨文拉里·埃里森(Larry Ellison)在D10 大会上发表的十大惊人言论.埃里森将惠普前CEO李艾 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq77kZz.html" rel="bookmark" class="title">Tomcat启动有时报错有是正常</a>
					<div>
						问题描述 Tomcat启动有时报错有是正常 应用部署好以后启动tomcat,有时会报错,有时能正常启动.(期间没有对程序做任何修改) 报如下错: Caused by: java.net.Connect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnxkmM.html" rel="bookmark" class="title">关于v4包冲突问题</a>
					<div>
						问题描述 项目使用的是aar包,里边有一些文件使用到了v4包,而我想把easeui作为我自己项目的module时,会报文件冲突,我自己项目里的v4包无法删除,而环信easeui中的v4也不能删除,这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22ldZb.html" rel="bookmark" class="title">互联网应急中心：谨防手机骷髅病毒危害智能手机</a>
					<div>
						中新网3月21日电 国家互联网应急中心(CNCERT/CC)监测发现,近期一个名为&quot;手机骷髅&quot;的手机病毒正在迅速传播,该病毒主要针对目前拥有大量用户的Symbian S60 3系列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8Kgjb.html" rel="bookmark" class="title">PHP&plus;HTML&plus;JavaScript&plus;Css实现简单爬虫开发&lowbar;php技巧</a>
					<div>
						开发一个爬虫,首先你要知道你的这个爬虫是要用来做什么的.我是要用来去不同网站找特定关键字的文章,并获取它的链接,以便我快速阅读. 按照个人习惯,我首先要写一个界面,理清下思路.     1.去不同网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEg8yp.html" rel="bookmark" class="title">Java设计模式之享元模式学习笔记</a>
					<div>
						享元模式(Flyweight Pattern)主要用于减少创建对象的数量,以减少内存占用和提高性能.这种这种类型的设计模式属于结构型模式,它提供了减少对象数量从而改善应用所需的对象结构的方式.享元模式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYErVb.html" rel="bookmark" class="title">jQuery实现对无序列表的排序功能&lpar;附demo源码下载&rpar;&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery实现对无序列表的排序功能.分享给大家供大家参考,具体如下: 利用jQuery对无序列表排序的原理是:获取到无序列表中的所有列表项,并转成数组形式,使用JavaScript函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2D54z.html" rel="bookmark" class="title">mysql创建内存表的方法&lowbar;Mysql</a>
					<div>
						如何创建内存表?创建内存表非常的简单,只需注明 ENGINE= MEMORY 即可: 复制代码 代码如下: CREATE TABLE  `tablename` ( `columnName` varch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWY9az.html" rel="bookmark" class="title">手机百度音乐怎么显示歌词 手机百度音乐显示歌词设置</a>
					<div>
						手机百度音乐我们保证它是最新版本才可以往下看了,具体如下. 1.我们在手机中打开 百度音乐播放页面 细节如下图 2.方法一:现在我们进入之后只要用手指向 左滑动专辑封面 如图 方法二:我们在界面点击[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv6LJM.html" rel="bookmark" class="title">什么是DNS劫持与DNS劫持常见手段总结</a>
					<div>
						什么是DNS劫持?DNS劫持又称域名劫持,是指通过某些手段取得某域名的解析控制权,修改此域名的解析结果,导致对该域名的访问由原IP地址转入到修改后的指定IP,其结果就是对特定的网址不能访问或访问的是假 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7YajM.html" rel="bookmark" class="title">CentOS上配置MariaDB主从复制配置教程</a>
					<div>
						环境说明 主库服务器: 192.168.71.151,CentOS 7,MariaDB 10已安装,无应用数据. 从库服务器1: 192.168.71.152,CentOS 7,MariaDB 10已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8JmNp.html" rel="bookmark" class="title">云计算优化与可靠性的重点是支持发展</a>
					<div>
						大多数企业中的IT团队都需要服务多位&quot;老板&quot;.首先,企业主需要依赖于业务应用程序,带动企业营收和提高生产力.其次,最终用户:无论是外部客户或是企业的内部员工,都需要卓越的最终用户体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G4Lop.html" rel="bookmark" class="title">大数据冲击大卖场 比父亲更了解女儿</a>
					<div>
						现在,如果不经常把&quot;大数据&quot;挂在口头,就如同5年前不知道&quot;云计算&quot;--意味着你已经落伍了.人们用它来描述和定义信息爆炸时代产生的海量数据,并命名与之相关的技术发 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
